/*
*/
/*******************************************************************/
/*	COPYRIGHT (C) 1995  Dana How
/*******************************************************************/

#include "gemini.h"

/*******************************************************************/
/* Run through the matching devices in the two graphs and
   dump their gate connections to the guess file.
/*******************************************************************/

void WriteGuess(graph1, graph2)
Graph *graph1, *graph2;
{
  int f0, f1;
  register Node *node1, *node2;
  register int count = graph1->uniqueDevices.size;
  int num = 0;
  FILE * f = fopen("guess", "w");
#define	GNET(node,t)	((node)->connects.netList[t])

  /* iterate through matched devices */

  node1 = graph1->uniqueDevices.top;
  node2 = graph2->uniqueDevices.top;
  for ( ; count--; node1 = node1->next, node2 = node2->next ) {

      /* if gate not matched, print it as a guess */
      if ( GNET(node1,3)->flag != UNIQUE ) {
        fprintf(f, "= %s %s\n", GNET(node1,3)->name, GNET(node2,3)->name);
        num++;
      }

      f0 = (GNET(node1,0)->flag == UNIQUE);
      f1 = (GNET(node1,1)->flag == UNIQUE);

      /* if both s and d matched, nothing more to print */
      if ( f0 && f1 )
	continue;

      /* if neither matched, print 2nd order guess! */
      if ( !f0 && !f1 ) {
	fprintf(f, ": %s %s\n", GNET(node1,0)->name, GNET(node2,0)->name);
	fprintf(f, ": %s %s\n", GNET(node1,1)->name, GNET(node2,1)->name);
	num += 2;
	continue;
      }

      /* if just one matched, print the other */
      fprintf(f, "= %s %s\n",
	GNET(node1,f0 ? 1 : 0)->name,
	GNET(node2, GNET(node2,0)->flag == UNIQUE ? 1 : 0)->name);
      num++;
      /* report it if the graph2 equiv doesn't have the same property */
      if ( (GNET(node2,0)->flag == UNIQUE) == (GNET(node2,1)->flag == UNIQUE) )
	fprintf(f, "!\n");
  }

  printf("%d entries written to the guess file.\n", num);
  fclose(f);
}
