/*
$Id: prototypes.h,v 2.7 1993/12/17 04:50:10 mckenzie Exp mckenzie $
*/
Device *NewDevice(register int index, register int deviceType, int numpins);
Graph *AllocGraph(void);
void AllocFingerHash(void);
Net *FindNet(register char *name);
Net *FindOrAllocNet(register char *name);
Net *NewNet(register char *name, register int index);
Net *RealNet(Net *net);
Node *MatchHT(Node *node, unsigned class);
Property *AllocProperty(void);
Queue *NewQueue(void);
SIMdevConnect *NewConnection(void);
#ifndef NOSTATIC
STATIC void initEqHash(register int size);
STATIC int computeEqValue(Node *aNode);
STATIC int newDeviceType(int type1, int type2);
STATIC int refinePartitions(Graph *graph1, Graph *graph2);
STATIC short cmpSuffix(register char *str1, int len1, register char *str2, int len2);
STATIC short readNode(FILE *FilePt, register Node *aNode, int nodetype, Graph *graph);
STATIC unsigned int hash(register unsigned char *name);
STATIC void InitTwoGraphs(register Graph *graph1, register Graph *graph2);
STATIC void SIMSetDeviceDefs(char);
STATIC void SIMSetDevices(register Graph *graph, register Device *devices);
STATIC void SIMSetNets(Graph *graph, register Net *nets);
STATIC void askContinue(void);
STATIC void combineDevices(Graph *graph, Node *net, Node *newDevice, Node *oldDevice);
STATIC void extractQueue(register Queue *inQueue, register Queue *result);
STATIC void popUpIndex(Net *net);
STATIC void queueNeighbors(Node *anode, register Queue *queue);
STATIC void readType(FILE *FilePt, register DeviceDefinition *aType);
STATIC void reconnectNet(Node *net, register Node *oldDevice, int oldTerminal, Node *newDevice, int newTerminal);
STATIC void setSuspectQueue(register Queue *newQueue, register Graph *graph);
STATIC void twoGraphs(Graph *graph1, Graph *graph2);
#endif
char *CopyString(char *string);
char *FastAlloc(register unsigned int size);
unsigned char *nxtarg(unsigned char **q, unsigned char *brk);
char *sbrk(int);
unsigned char *skipover(unsigned char *string, unsigned char *charset);
unsigned char *skipto(unsigned char *string, unsigned char *charset);
/* char *strcpy(char *, const char *); */
double atof(const char *);
double fabs(double);
int AssignMatch(Graph *graph1, Graph *graph2);
int EqPartition(Queue *partition);
int FindEqName(char *name, int circuit);
int InsertEqName(register unsigned char *name, int circuit, int value);
int InsertHT(Node *node, unsigned class);
int QueueOK(register Queue *queue);
int RelabelGraphs(register Graph *graph1, register Graph *graph2);
int casestreq(register char *s1, register char *s2);
int nocasestreq(register char *s1, register char *s2);
void AddDevice(Device *device);
void AllocHashTable(Graph *graph);
void AppendUniques(register Graph *graph);
void AssignInitialValue(register Node *node, int circuit);
void AssignNewValues(register Graph *graph);
void CheckChains(Graph *graph1, Graph *graph2);
void CheckEquates(void);
void CleanPendingArray(Graph *graph, int whichNodes, register Queue *queue);
void CompareProperties(Graph *graph1, Graph *graph2);
void CompareNetProperties(Graph *graph1, Graph *graph2);
void ComputeValue(Node *aNode);
void DeleteNet(Graph *graph, register Node *net);
void EnterHash(Node *aNode, Graph *graph);
void EquateNets(Graph *graph, register Net *net1, register Net *net2);
void FindChains(Graph *graph);
void FinishHT(register Graph *graph);
void GetNodes(Device **devices, Net **nets);
void IncrementValue(Node *aNode, int value, int class);
void InitCharTran(void);
void InitHash(register int size);
void InitHashTable(register Graph *graph, register int numberNodes);
void InitNets(void);
void InitialDeviceValues(register Graph *graph);
void InitialNetValues(register Graph *graph);
void InserSortQ(register Queue *queue);
void LocalMatch(Graph *graph1, register Node *node1, Graph *graph2, register Node *node2);
void LocalMatchUniques(Graph *graph1, Graph *graph2);
void MagicOutNode(register Node *node, char *error);
void MagicOutQueue(register Queue *queue);
int MatchBySuffix(Queue *queue1, Queue *queue2);
void MatchPartitions(Graph *graph1, Graph *graph2);
void MatchUniques(Graph *graph1, Graph *graph2);
void PrintAllNets(void);
void PrintHashTable(register Graph *graph);
void PrintNode(register Node *node);
void PrintNodeNeighbors(register Node *node);
void PrintNodes(register Node *nodes, register int numNodes);
void PrintQueue(Queue *queue);
void PrintTypes(DeviceDefinition *defs, int numDefs);
void ProcessUniques(register Graph *graph);
void ReadEqFile(char *EqFileName);
void ReadGemFormat(FILE *infilePT, Graph *graph);
void ReadGraph(register Graph *graph, int simFormat);
void ReadSimFile(FILE *infile, Graph *graph, Device **devices, Net **nets);
void ReadSimFormat(FILE *infilePT, register Graph *graph);
void ResetBad(register Graph *graph);
void ResetSuspects(register Graph *graph);
void SortQueue(register Queue *queue);
void StartNewHT(int size);
void WriteDictionary(Graph *graph1, Graph *graph2);
void main(int argc, char **argv);
void removeFromQueue(Queue *queue, Node *node);
void CombineFingers(Graph *graph);
void UserDefLine(int, unsigned char **, int);
